#!/bin/sh
# the next line executes the program\
exec wish "$0" "$@"

# MAYBE YOU MUST USE ONE OF THE FOLLOWING LINES
# exec /usr/local/bin/wish "$0" "$@"
# exec /home/meolic/ActiveTcl/bin/wish "$0" "$@"

#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 13 $]
#  Date        [$Date: 2007-07-19 14:02:50 +0200 (Thu, 19 Jul 2007) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 1999, 2003, 2006, 2007
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global TITLE
global ICONNAME
global PROMPT
global BINDIR

# --------------
# identification
# --------------

set TITLE "EST - Efficient Symbolic Tools, 1st Edition"
set ICONNAME "EST"
set PROMPT "EST> "

# ------------
# OS
# ------------

set OS $tcl_platform(platform)

# ------------
# folder 
# ------------

cd [file dirname [info script]]
set BINDIR [pwd]

# ####################################################################
# Start My Interface Tcl/Tk GUI
# ####################################################################

source $BINDIR/mi.tcl
mi_initPkg
source $BINDIR/miDialog.tcl

# ####################################################################
# Say hello
# ####################################################################

outline "Efficient Symbolic Tools, 1st Edition, Copyright (C) 2007 UM-FERI"
outline "This is free software, and comes with ABSOLUTELY NO WARRANTY."
outline "You are welcome to redistribute EST; type \"license\" for details."
outline ""
outline "Running on $tcl_platform(machine) ($tcl_platform(os), $tcl_platform(osVersion)) with tcl $tcl_patchLevel and tk $tk_patchLevel." 
outline ""

# ####################################################################
# GUI package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/gui.so}
if {$OS == "windows"} {load $BINDIR/gui.dll}
gui_initPkg

# GUI package does not provide any dialogs

# ####################################################################
# BDD package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/bdd.so}
if {$OS == "windows"} {load $BINDIR/bdd.dll}
bdd_initPkg

source $BINDIR/bddDialog.tcl

# ####################################################################
# Process algebra package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/pa.so}
if {$OS == "windows"} {load $BINDIR/pa.dll}
pa_initPkg

source $BINDIR/paDialog.tcl

# ####################################################################
# Versis package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/versis.so}
if {$OS == "windows"} {load $BINDIR/versis.dll}
versis_initPkg

source $BINDIR/versisDialog.tcl

# ####################################################################
# Model checking package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/mc.so}
if {$OS == "windows"} {load $BINDIR/mc.dll}
mc_initPkg

source $BINDIR/mcDialog.tcl

# ####################################################################
# Change to the default folder
# ####################################################################

cd $BINDIR/../data
outline ""

# ####################################################################
# DEBUGGING ONLY
# ####################################################################

proc myexit { } {
  mc_exitPkg
  versis_exitPkg
  pa_exitPkg
  bdd_exitPkg
}
