#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 13 $]
#  Date        [$Date: 2007-07-19 14:02:50 +0200 (Thu, 19 Jul 2007) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 1999, 2003, 2006, 2007
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.mc \
         .menuFrame.mc.menu \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.mc

menubutton .menuFrame.mc -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.mc.menu -pady 1 -text "Model checking"
pack .menuFrame.mc -side left
menu .menuFrame.mc.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.mc.menu add command  -command menu_mc_checkACTL -label "mc_check_actl"
.menuFrame.mc.menu add separator 
.menuFrame.mc.menu add command  -command mc_about -label "mc_about"

proc mc_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        mc_aboutPkg
        set f [open "$BINDIR/mc.about" r]
	
	while {[gets $f line] >= 0} {
          out "\# "
	  outline $line
	}	
        outline "\#\#\# "
	close $f
}

proc menu_mc_checkACTL {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "mc_check_actl"
	set SYNOPSIS "ACTL model checking."
	set SYNTAX "type%d pname%s fname%s"
	set EXAMPLE "mc_check_actl 0 p f.actl"
	set EXPLANATION "Check ACTL formulas in file f.actl on process p"
	
        set BROWSE [list \
          {name "Select process/composition" proccomp} \
          {file "Select file with ACTL/ACTLW formulae" {{{ACTL/ACTLW formulae} {.actl}}}} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}
