/**CFile*******************************************************************
  PackageName [mc]
  Synopsis    [Package 'mc' provides a symbolic ACTLW model checker]

  FileName    [mcParser.l]
  Revision    [$Revision: 13 $]
  Date        [$Date: 2007-07-19 14:02:50 +0200 (Thu, 19 Jul 2007) $]
  Author      [Robert Meolic (meolic@uni-mb.si)]
  Description [File  mcParser.y is a flex file for ACTLW parser.]
  SeeAlso     [mc.h, mcInt.h, mcParser.y]

  Copyright   [This file is part of EST (Efficient Symbolic Tools).
               Copyright (C) 1999, 2003, 2006, 2007
               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia

               EST is free software; you can redistribute it and/or modify
               it under the terms of the GNU General Public License as
               published by the Free Software Foundation; either version 2
               of the License, or (at your option) any later version.

               EST is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
               Boston, MA 02110-1301 USA.]
  ************************************************************************/

ACTION    	[-_A-Za-z0-9][-_A-Za-z0-9]*[?!]
VALTRUE         true|True|TRUE
VALFALSE        false|False|FALSE
NOT             not|Not|NOT
AND             and|And|AND
OR              or|Or|OR
EQV             eqv|Eqv|EQV
IMPL            impl|Impl|IMPL
TAU             tau|tAu|taU|tAU|Tau|TAu|TaU|TAU
EPSILON         epsilon|Epsilon|EPSILON
OUTLINE 	#.*

%%
  int ch, inComm;

"/*"              { for(inComm=1; inComm; )
                    { switch(ch=input())
 			{ case '\n' : break;
			  case '*'  : if (( ch=input()) == '/')
					inComm=0;
				      else  unput(ch);
				break;
                        }
                    }
                  }	

[ ]		{/* preskok praznih mest */}

[\t\n\r]	{/* preskok praznega prostora */}

"'"	        {/* qoutes are ignored */}

"\""	        {/* qoutes are ignored */}

E		{return E;}
A		{return A;}
U		{return UNTIL;}
EX		{return EX;}
AX		{return AX;}
EF		{return EF;}
AF		{return AF;}
EG		{return EG;}
AG		{return AG;}

EE		{return EE;}
AA		{return AA;}
W		{return UNLESS;}
UU		{return UNLESS;}
EEX		{return EEX;}
AAX		{return AAX;}
EEF		{return EEF;}
AAF		{return AAF;}
EEG		{return EEG;}
AAG		{return AAG;}

"~"		{return NOT;}
"*"		{return AND;}
"&"		{return AND;}
"+"		{return OR;}
"|"		{return OR;}
"<->"		{return EQV;}
"->"		{return IMPL;}

{NOT}		{return NOT;}
{AND}		{return AND;}
{OR}		{return OR;}
{EQV}		{return EQV;}
{IMPL}		{return IMPL;}

"("	        {return yytext[0];}
")"	        {return yytext[0];}
"{"	        {return yytext[0];}
"}"		{return yytext[0];}
"["		{return yytext[0];}
"]"		{return yytext[0];}
"<"		{return yytext[0];}
">"		{return yytext[0];}
";"		{return yytext[0];}

{ACTION}	{
                 yylval.name = strdup(yytext);
                 return ACTION;
                }

{VALTRUE}       {
                 yylval.name = strdup("true");
                 return VALTRUE;
                }

{VALFALSE}      {
                 yylval.name = strdup("false");
                 return VALFALSE;
                }

{TAU}	        {
                 yylval.name = strdup("TAU");
                 return TAU;
                }

{EPSILON}	{
                 yylval.name = strdup("EPSILON");
                 return EPSILON;
                }

{OUTLINE}	{
                 yylval.name = strdup(yytext);
                 return OUTLINE;
                }

.               {
                 return UNKNOWN;
                }
%%
