#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 13 $]
#  Date        [$Date: 2007-07-19 14:02:50 +0200 (Thu, 19 Jul 2007) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 1999, 2003, 2006, 2007
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.pa \
         .menuFrame.pa.menu \
           .menuFrame.pa.processes \
           .menuFrame.pa.compositions \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.pa

menubutton .menuFrame.pa -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.pa.menu -pady 1 -text "Process algebra"
pack .menuFrame.pa -side left
menu .menuFrame.pa.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.pa.menu add command  -command menu_pa_readProcess -label "pa_read_process"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_writeSort -label "pa_write_sort"
.menuFrame.pa.menu add command  -command menu_pa_writeProcess -label "pa_write_process"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_encodeSort -label "pa_encode_sort"
.menuFrame.pa.menu add command  -command menu_pa_encodeProcess -label "pa_encode_process"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_decodeProcess -label "pa_decode_process"
.menuFrame.pa.menu add command  -command menu_pa_decodeProcVisible -label "pa_decode_proc_visible"
.menuFrame.pa.menu add command  -command menu_pa_decodeComposition -label "pa_decode_composition"
.menuFrame.pa.menu add command  -command menu_pa_decodeCompVisible -label "pa_decode_comp_visible"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add cascade  -label "Processes..." -menu .menuFrame.pa.processes
.menuFrame.pa.menu add cascade  -label "Compositions..." -menu .menuFrame.pa.compositions
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command pa_about -label "pa_about"

menu .menuFrame.pa.processes -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.pa.processes add command  -command menu_pa_stateNumber -label "pa_state_number"
.menuFrame.pa.processes add command  -command menu_pa_transitionNumber -label "pa_transition_number"
.menuFrame.pa.processes add command  -command menu_pa_transitionVisible -label "pa_transition_visible"

menu .menuFrame.pa.compositions -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.pa.compositions add command  -command menu_pa_compStateNumber -label "pa_comp_state_number"
.menuFrame.pa.compositions add command  -command menu_pa_compTransitionNumber -label "pa_comp_transition_number"
.menuFrame.pa.compositions add command  -command menu_pa_compTransitionVisible -label "pa_comp_transition_visible"

proc pa_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        pa_aboutPkg
        set f [open "$BINDIR/pa.about" r]
	
	while {[gets $f line] >= 0} {
          out "\# "
	  outline $line
	}	
        outline "\#\#\# "
	close $f
}

proc menu_pa_readProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_read_process"
	set SYNOPSIS "Read file."
	set SYNTAX "fname%s"
	set EXAMPLE "pa_read_process data/system.dat"
	set EXPLANATION "Read file ./data/system.dat"
	
        set BROWSE [list \
          {file "Select file" {{{Internal format} {.dat}}}} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_writeSort {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_write_sort"
	set SYNOPSIS "Write sort."
	set SYNTAX "sname%s"
	set EXAMPLE "pa_write_sort mysort"
	set EXPLANATION "Write out sort mysort"
	
        set BROWSE [list \
          {name "Select sort" sort} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_writeProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_write_process"
	set SYNOPSIS "Write process."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_write_process myprocess"
	set EXPLANATION "Write out process myprocess"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_encodeSort {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_encode_sort"
	set SYNOPSIS "Encode sort."
	set SYNTAX "sname%s"
	set EXAMPLE "pa_encode_sort mysort"
	set EXPLANATION "Encode sort mysort"
	
        set BROWSE [list \
          {list "Select list of sorts" sort} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_encodeProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_encode_process"
	set SYNOPSIS "Encode process."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_encode_process myprocess"
	set EXPLANATION "Encode process myprocess"
	
        set BROWSE [list \
          {list "Select list of processes" proc} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_decode_process"
	set SYNOPSIS "Decode process."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_process myprocess"
	set EXPLANATION "Decode process myprocess"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeProcVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_decode_proc_visible"
	set SYNOPSIS "Decode visible part of process."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_proc_visible myprocess"
	set EXPLANATION "Decode visible part of process myprocess"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeComposition {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_decode_composition"
	set SYNOPSIS "Decode composition."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_composition mycomposition"
	set EXPLANATION "Decode composition mycomposition"
	
        set BROWSE [list \
          {name "Select composition" comp} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_pa_decodeCompVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_decode_comp_visible"
	set SYNOPSIS "Decode visible part of composition."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_comp_visible mycomposition"
	set EXPLANATION "Decode visible part of composition mycomposition"
	
        set BROWSE [list \
          {name "Select composition" comp} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_stateNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "pa_state_number"
	set SYNOPSIS "Count states in a process."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_state_number myprocess\]"
	set EXPLANATION "Count states in process myprocess"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD "outline \[$NAME"
        set CMDEND "\]"
        set PARAM ""

	commonDialog
	
}

proc menu_pa_transitionNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "pa_transition_number"
	set SYNOPSIS "Count transitions in a process."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_transition_number myprocess\]"
	set EXPLANATION "Count transitions in process myprocess"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD "outline \[$NAME"
        set CMDEND "\]"
        set PARAM ""
	
	commonDialog
	
}

proc menu_pa_transitionVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM
	
	set NAME "pa_transition_visible"
	set SYNOPSIS "Count visible transitions in a process."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_transition_visible myprocess\]"
	set EXPLANATION "Count visible transitions in process myprocess"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD "outline \[$NAME"
        set CMDEND "\]"
        set PARAM ""

	commonDialog
	
}

proc menu_pa_compStateNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "pa_comp_state_number"
	set SYNOPSIS "Count states in a composition."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_comp_state_number mycomposition\]"
	set EXPLANATION "Count states in composition mycomposition"
	
        set BROWSE [list \
          {name "Select composition" comp} \
        ]

        set CMD "outline \[$NAME"
        set CMDEND "\]"
        set PARAM ""

       	commonDialog
	
}

proc menu_pa_compTransitionNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "pa_comp_transition_number"
	set SYNOPSIS "Count transitions in a composition."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_comp_transition_number mycomposition\]"
	set EXPLANATION "Count transitions in composition mycomposition"
	
        set BROWSE [list \
          {name "Select composition" comp} \
        ]

        set CMD "outline \[$NAME"
        set CMDEND "\]"
        set PARAM ""

	commonDialog
	
}

proc menu_pa_compTransitionVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "pa_comp_transition_visible"
	set SYNOPSIS "Count visible transitions in a composition."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_comp_transition_visible mycomposition\]"
	set EXPLANATION "Count visible transitions in composition mycomposition"
	
        set BROWSE [list \
          {name "Select composition" comp} \
        ]

        set CMD "outline \[$NAME"
        set CMDEND "\]"
        set PARAM ""
	
	commonDialog
	
}
