#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 13 $]
#  Date        [$Date: 2007-07-19 14:02:50 +0200 (Thu, 19 Jul 2007) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 1999, 2003, 2006, 2007
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.versis \
         .menuFrame.versis.menu \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.versis

menubutton .menuFrame.versis -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.versis.menu -pady 1 -text "Versis"
pack .menuFrame.versis -side left
menu .menuFrame.versis.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.versis.menu add command  -command menu_versis_compose -label "versis_compose"
.menuFrame.versis.menu add separator 
.menuFrame.versis.menu add command  -command menu_versis_strongEquivalence -label "versis_strong_equivalence"
.menuFrame.versis.menu add command  -command menu_versis_weakEquivalence -label "versis_weak_equivalence"
.menuFrame.versis.menu add command  -command menu_versis_testingEquivalence -label "versis_testing_equivalence"
.menuFrame.versis.menu add separator 
.menuFrame.versis.menu add command  -command menu_versis_changeRename -label "versis_change_rename"
.menuFrame.versis.menu add command  -command menu_versis_changeHide -label "versis_change_hide"
.menuFrame.versis.menu add command  -command menu_versis_changeForbid -label "versis_change_forbid"
.menuFrame.versis.menu add command  -command menu_versis_checkDeadlock -label "versis_check_deadlock"
.menuFrame.versis.menu add command  -command menu_versis_checkDivergence -label "versis_check_divergence"
.menuFrame.versis.menu add separator 
.menuFrame.versis.menu add command  -command versis_about -label "versis_about"

proc versis_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        versis_aboutPkg
        set f [open "$BINDIR/versis.about" r]
	
	while {[gets $f line] >= 0} {
          out "\# "
	  outline $line
	}	
        outline "\#\#\# "
	close $f
}

proc menu_versis_compose {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_compose"
	set SYNOPSIS "Compose processes."
	set SYNTAX "type%d pname%s num%d \"pname%s pname%s ...\"num%d \"aname%s aname%s ...\""
	set EXAMPLE "versis_compose 1 c 2 \"p1 p2\" 1 \"a1\""
	set EXPLANATION "Compose proceses p1 and p2, a1 is non-restricted action"
	
        set BROWSE [list \
          {comtypeold "Select composition type" ""} \
          {nonempty "Composition name" 30} \
          {list "Select list of processes" proc} \
          {required "List of action names (optional)" 30} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""
	
	commonDialog
	
}

proc menu_versis_strongEquivalence {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_strong_equivalence"
	set SYNOPSIS "Checking strong observational equivalence."
	set SYNTAX "type%d pname%s type%d pname%s"
	set EXAMPLE "versis_strong_equivalence 0 p 1 c"
	set EXPLANATION "Checking equivalence between proces p and composition c"
	
        set BROWSE [list \
          {name "Select first process/composition" proccomp} \
          {name "Select second process/composition" proccomp} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_weakEquivalence {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_weak_equivalence"
	set SYNOPSIS "Checking weak observational equivalence."
	set SYNTAX "type%d pname%s type%d pname%s"
	set EXAMPLE "versis_weak_equivalence 0 p 1 c"
	set EXPLANATION "Checking equivalence between proces p and composition c"
	
        set BROWSE [list \
          {name "Select first process/composition" proccomp} \
          {name "Select second process/composition" proccomp} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_testingEquivalence {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_testing_equivalence"
	set SYNOPSIS "Checking testing equivalence."
	set SYNTAX "type%d pname%s type%d pname%s"
	set EXAMPLE "versis_testing_equivalence 0 p 1 c"
	set EXPLANATION "Checking equivalence between proces p and composition c"
	
        set BROWSE [list \
          {name "Select first process/composition" proccomp} \
          {name "Select second process/composition" proccomp} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_changeRename {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_change_rename"
	set SYNOPSIS "Rename action in the process."
	set SYNTAX "pname%s aname%s aname%s"
	set EXAMPLE "versis_change_rename p a1 b1"
	set EXPLANATION "In process p rename action a1 to b1"
	
        set BROWSE [list \
          {name "Select process" proc} \
          {nonempty "Original action name" 30} \
          {nonempty "New action name" 30} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_changeHide {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_change_hide"
	set SYNOPSIS "Hide action in the process."
	set SYNTAX "pname%s aname%s"
	set EXAMPLE "versis_change_hide p a"
	set EXPLANATION "In process p hide action a"
	
        set BROWSE [list \
          {name "Select process" proc} \
          {nonempty "Action name" 30} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_changeForbid {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_change_forbid"
	set SYNOPSIS "Forbid action in the process."
	set SYNTAX "pname%s aname%s"
	set EXAMPLE "versis_change_forbid p a"
	set EXPLANATION "In process p forbid action a"
	
        set BROWSE [list \
          {name "Select process" proc} \
          {nonempty "Action name" 30} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_checkDeadlock {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_check_deadlock"
	set SYNOPSIS "Check possibility of deadlock in process."
	set SYNTAX "pname%s"
	set EXAMPLE "versis_check_deadlock p"
	set EXPLANATION "Check if there exists deadlock in process p"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}

proc menu_versis_checkDivergence {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
        global CMD
        global CMDEND
        global PARAM

	set NAME "versis_check_divergence"
	set SYNOPSIS "Check possibility of divergence in process."
	set SYNTAX "pname%s"
	set EXAMPLE "versis_check_divergence p"
	set EXPLANATION "Check if there exists divergent state in process p"
	
        set BROWSE [list \
          {name "Select process" proc} \
        ]

        set CMD $NAME
        set CMDEND ""
        set PARAM ""

	commonDialog
	
}
